%define anolis_release 1
%global nginx_user nginx
%global nginx_moduledir %{_libdir}/%{name}/modules
%global nginx_moduleconfdir %{_datadir}/%{name}/modules
%bcond_with qatzip

Name:		asynch_mode_nginx
Version:	0.5.0
Release:	%{anolis_release}%{?dist}
Summary:	Asynch Mode for NGINX*
License:	BSD
URL:		https://github.com/intel/asynch_mode_nginx
Source0:	https://github.com/intel/asynch_mode_nginx/archive/refs/tags/v0.5.0.tar.gz
Source1:	macros.asynch_mode_nginxmods.in
	
BuildRequires:	openssl-devel > 3.0.7
	
%if %{with qatzip}
BuildRequires:  qatzip-devel
%endif

BuildRequires:  pcre2-devel
BuildRequires:  zlib-devel

Patch1:		1001-add-load_modules.patch

%description
Nginx* [engine x] is an HTTP and reverse proxy server, a mail proxy server, 
and a generic TCP/UDP proxy server, originally written by Igor Sysoev. This
project provides an extended Nginx working with asynchronous mode OpenSSL*. 
With Intel® QuickAssist Technology (QAT) acceleration, Asynch Mode for
NGINX* can provide significant performance improvement.

%package doc
Summary:        Documentation files for %{name}
Requires:       %{name} = %{version}-%{release}
BuildArch:      noarch

%description    doc
The %{name}-doc package contains documentation files for %{name}.

%prep
%autosetup -n %{name}-%{version} -p1

%build
./configure \
	--prefix=%{_datadir}/%{name} \
	--sbin-path=%{_sbindir}/%{name} \
	--modules-path=%{nginx_moduledir} \
	--conf-path=%{_sysconfdir}/%{name}/%{name}.conf \
	--error-log-path=%{_localstatedir}/log/%{name}/error.log \
	--http-log-path=%{_localstatedir}/log/%{name}/access.log \
	--http-client-body-temp-path=%{_localstatedir}/lib/%{name}/tmp/client_body \
	--http-proxy-temp-path=%{_localstatedir}/lib/%{name}/tmp/proxy \
	--http-fastcgi-temp-path=%{_localstatedir}/lib/%{name}/tmp/fastcgi \
	--http-uwsgi-temp-path=%{_localstatedir}/lib/%{name}/tmp/uwsgi \
	--http-scgi-temp-path=%{_localstatedir}/lib/%{name}/tmp/scgi \
	--with-http_ssl_module \
%if %{with qatzip}
	--add-dynamic-module=modules/nginx_qatzip_module \
%endif
	--add-dynamic-module=modules/nginx_qat_module/  \
	--pid-path=/run/%{name}.pid \
	--lock-path=/run/lock/subsys/%{name} \
	--user=%{nginx_user} \
	--group=%{nginx_user} \
	--with-debug


%make_build

%install
%make_install
install -p -d -m 0700 %{buildroot}%{_localstatedir}/lib/%{name}
install -p -d -m 0700 %{buildroot}%{_localstatedir}/lib/%{name}/tmp
install -p -d -m 0700 %{buildroot}%{_localstatedir}/log/%{name}
mv %{buildroot}/%{_sysconfdir}/%{name}/nginx.conf.default %{buildroot}/%{_sysconfdir}/%{name}/%{name}.conf.default

install -p -d -m 0755 %{buildroot}%{_datadir}/%{name}/modules
install -p -d -m 0755 %{buildroot}%{_libdir}/%{name}/modules
echo 'load_module %{nginx_moduledir}/ngx_ssl_engine_qat_module.so";' \
	> %{buildroot}/%{nginx_moduleconfdir}/mod-ssl-engine-qat.conf
%if %{with qatzlib}
echo 'load_module %{nginx_moduledir}/ngx_http_qatzip_filter_module.so";' \
         > %{buildroot}/%{nginx_moduleconfdir}/mod-http-qatzip-filter.conf
%endif

## Install rpm macros
mkdir -p %{buildroot}%{_rpmmacrodir}
sed -e "s|@@ASYNCH_MODE_NGINX_ABIVERSION@@|%{version}|g" \
    -e "s|@@ASYNCH_MODE_NGINX_MODDIR@@|%{nginx_moduledir}|g" \
    -e "s|@@ASYNCH_MODE_NGINX_MODCONFDIR@@|%{nginx_moduleconfdir}|g" \
    %{SOURCE1} > %{buildroot}%{_rpmmacrodir}/macros.%{name}mods

%files
%license LICENSE
%dir %{_datadir}/%{name}
%dir %{_sysconfdir}/%{name}
%{_datadir}/%{name}/html/*
%{_sbindir}/%{name}
%config(noreplace) %{_sysconfdir}/%{name}/fastcgi.conf
%config(noreplace) %{_sysconfdir}/%{name}/fastcgi.conf.default
%config(noreplace) %{_sysconfdir}/%{name}/fastcgi_params
%config(noreplace) %{_sysconfdir}/%{name}/fastcgi_params.default
%config(noreplace) %{_sysconfdir}/%{name}/koi-utf
%config(noreplace) %{_sysconfdir}/%{name}/koi-win
%config(noreplace) %{_sysconfdir}/%{name}/mime.types
%config(noreplace) %{_sysconfdir}/%{name}/mime.types.default
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf
%config(noreplace) %{_sysconfdir}/%{name}/%{name}.conf.default
%config(noreplace) %{_sysconfdir}/%{name}/scgi_params
%config(noreplace) %{_sysconfdir}/%{name}/scgi_params.default
%config(noreplace) %{_sysconfdir}/%{name}/uwsgi_params
%config(noreplace) %{_sysconfdir}/%{name}/uwsgi_params.default
%config(noreplace) %{_sysconfdir}/%{name}/win-utf
%dir %{nginx_moduledir}
%dir %{nginx_moduleconfdir}
%if %{with qatzlib}
%{nginx_moduledir}/ngx_http_qatzip_filter_module.so
%{nginx_moduleconfdir}/mod-http-qatzip-filter.conf
%endif
%{nginx_moduledir}/ngx_ssl_engine_qat_module.so
%{nginx_moduleconfdir}/mod-ssl-engine-qat.conf
%attr(770,%{nginx_user},root) %dir %{_localstatedir}/lib/%{name}
%attr(770,%{nginx_user},root) %dir %{_localstatedir}/lib/%{name}/tmp
%attr(711,root,root) %dir %{_localstatedir}/log/%{name}
%ghost %attr(640,%{nginx_user},root) %{_localstatedir}/log/%{name}/access.log
%ghost %attr(640,%{nginx_user},root) %{_localstatedir}/log/%{name}/error.log
%{_rpmmacrodir}/macros.%{name}mods

%files doc
%doc README.md

%changelog
* Wed Mar 01 2023 happy_orange <songnannan@linux.alibaba.com> - 0.5.0-1
- init package
